function [smernik,msmernik] = m_smernik(xA,yA,mxA,myA,xB,yB,mxB,myB)
%
%smernik = smernikAB(xA,yA,xB,yB)
%
%vpocet smerniku AB
%
rog = 200/pi;
romc = 2000/pi;


smernik = rog * atan2(yB-yA,xB-xA);

if smernik < 0
    smernik = smernik + 400;
end


s = ((yB-yA)^2 + (xB-xA)^2)^0.5;
X = xB - xA;
Y = yB - yA;

msmernik = romc * ((-X/s^2)^2 * myA^2 + (Y/s^2)^2 * mxA^2 + (X/s^2)^2 * myB^2 + (-Y/s^2)^2 * mxB^2)^0.5;

