clear
clc



mereni;
data = mereni(:,1:3);
format long g;



mer = 100; %zvetsen ste v Rocinante (kvili vyslednzm chybam, pro mer = 1 vychazi 0.00)


ro = 200 / pi;

pb = 4; %pocet bodu na nichz se merily smery

%fid = 1;
fid = fopen('vtig_u04.txt','w'); %vytvoreni *.txt souboru pro vystup
fid_W = fopen('vtig_u04_Geo-W.txt','w'); %vytvoreni *.txt souboru pro vstupni soubor pro Geo-W
fid_R = fopen('vtig_u04_Roci.gkf','w'); %vytvoreni *.txt souboru pro vstupni soubor pro Geo-W

%fid_R = 1;


m0 = 3.6; %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%




n = 0; %pocet trojuhelnku (kombinacn cslo:3 C pb)
Su0u0 = 0; %Suma ctvercu uzveru 0.etapy
% Su1u1 = 0; %Suma ctvercu uzveru 1.etapy
% SDuDu = 0; %Suma ctvercu rozdlu uzaveru 0. a 1. etapy

fprintf(fid,'    trojuhelnk        uzver\n');
fprintf(fid,'     i   j   k          [cc]  \n');
fprintf(fid,'----------------------------------\n');


for i=1:pb
    for j=i+1:pb
        for k=j+1:pb
            n = n + 1;
            
            u0 = uzaver(i,j,k,0,data);
            Su0u0 = Su0u0 + u0^2;
            
            
%            fprintf(fid,'%2.f:  %.f - %.f - %.f        %6.1f %s       %6.1f %s      %6.1f %s\n',n,i,j,k,u0,u0t,u1,u1t,u0-u1,Dut);
            fprintf(fid,'%2.f:  %.f - %.f - %.f        %6.1f \n',n,i,j,k,u0);            
        end
    end
end

fprintf(fid,'----------------------------------\n');
fprintf(fid,'[UU]                  %6.1f     \n',Su0u0);




fprintf(fid,'\n\n\n\n');




    [a,b] = size(s0);
    krok = a / pb;
    
    fprintf(fid,' stanovisko    s fi I [cc] \n');
    fprintf(fid,'--------------------------\n');

    X_s_fi_I = [];
    
    
    for i=1:pb
        od = i * krok - krok + 1;
        do = od + krok - 1;
        
        s_fi_I_0et = s_fi_I(s0(od:do,:));
  
        X_s_fi_I(i) = 3.6;
        
        fprintf(fid,'     %.f          %6.1f   \n',i,s_fi_I_0et);
    end

fprintf(fid,'\n\n\n\n');



s_fi_II_0et = (Su0u0 / (6 * n))^0.5;

fprintf(fid,'s fi II 0.etapa = %4.1f cc\n',s_fi_II_0et);





fprintf(fid,'\n\n\n\n');




    [a,b] = size(z0);
    krok = a / pb;
    
    fprintf(fid,' stanovisko    s zenit [cc] \n');
    fprintf(fid,'--------------------------\n');
    
    X_s_z = [];
    
    for i=1:pb
        od = i * krok - krok + 1;
        do = od + krok - 1;
        
        s_z_0et = s_z(z0(od:do,:));
  
        X_s_z(i) = 3.6; %s_z_0et;
        
        fprintf(fid,'     %.f           %6.1f \n',i,s_z_0et);
    end

fprintf(fid,'\n\n\n\n');




X_s_p = zeros(1,4) + 1; %str.ch.prevyseni

prev = prevyseni(mereni,10,X_s_p);

[n,pom] = size(prev);

    fprintf(fid,'    peven \n');
    fprintf(fid,' z  na       [m] \n');    
    fprintf(fid,'--------------------------\n');

for i=1:n
    fprintf(fid,' %2.i %2.i %9.4f \n',prev(i,1:2),prev(i,3) );%stanovisko , cl , zenitka [cc], vha
end


fprintf(fid,'\n\n\n\n');


fprintf(fid,'    trojuhelnk    vkov uzvr\n');
fprintf(fid,'     i   j   k          [mm]  \n');
fprintf(fid,'----------------------------------\n');

n = 0;
for i=1:pb
    for j=i+1:pb
        for k=j+1:pb
            n = n + 1;
            
            u0 = uzaver_d(i,j,k,0,prev);
            %Su0u0 = Su0u0 + u0^2;
            
            
%            fprintf(fid,'%2.f:  %.f - %.f - %.f        %6.1f %s       %6.1f %s      %6.1f %s\n',n,i,j,k,u0,u0t,u1,u1t,u0-u1,Dut);
            fprintf(fid,'%2.f:  %.f - %.f - %.f        %6.2f \n',n,i,j,k,u0);            
        end
    end
end

% fprintf(fid,'----------------------------------\n');
% fprintf(fid,'[UU]                  %6.1f     \n',Su0u0);





fprintf(fid,'\n\n\n\n');




X_s_d = (1000 * (   zeros(1,4) + sqrt(  (0.01 + ( (0.00026/ro) * 7000 * (1/tan(98/ro)) )^2   ) / (  (sin(98/ro))^2  )   )     )); %str.ch. delky

delky = delka(mereni,10,X_s_d);




fprintf(fid,'<------------------------<>------------------------>\n');

fprintf(fid,'''VTIG: Mikrost - skupina 4''\n');

%fprintf(fid,'%4.2f 0.00 %4.2f 0.00\n',2^0.5 * sig_fi_3,2^0.5 * sig_fi_3); %smerodatn odchylka: rozdlu hlu [cc] , rozdlu dlek [mm] , jednotkov , souradnicov [mm]
fprintf(fid,'3.6 0.8 3.6 %4.2f 0.00\n',m0); 


[n,pom] = size(body);

for i=1:n
    
    if(body(i,1) == 1)
        kod = 7;
    elseif(body(i,1) == 2)
        kod = 2;
    else
        kod = 0;
    end
    
    fprintf(fid,' %2.i %i %10.1f %10.1f %10.1f\n',body(i,1),kod,1000*body(i,3),1000*body(i,2),1000*body(i,4));%bod , kod , X [mm], Y [mm] (kod:)
end

fprintf(fid,'-1\n');%nasleduji vodorovne mery

[n,pom] = size(data);

for i=1:n
    fprintf(fid,' %2.i %2.i %9.1f %6.2f\n',data(i,1:2),10000*data(i,3) , m0^2 / X_s_fi_I(data(i,1))^2   );%stanovisko , cl , smer [cc], vha
end

fprintf(fid,'-1\n');%naleduji zenitky

zenitky = zenit(mereni,10,X_s_z);

[n,pom] = size(zenitky);

for i=1:n
    fprintf(fid,' %2.i %2.i %9.1f %6.2f\n',zenitky(i,1:2),10000*zenitky(i,3),  m0^2 / zenitky(i,4)^2 );%stanovisko , cl , zenitka [cc], vha
end


fprintf(fid,'-1\n');%nasleduji sikme delky

[n,pom] = size(delky);

for i=1:n
    fprintf(fid,' %2.i %2.i %9.1f %6.4f\n',delky(i,1:2),1000*delky(i,5), m0^2 / X_s_d(1,1)^2 );%stanovisko , cl , zenitka [cc], vha
end


fprintf(fid,'-1\n');

fprintf(fid,'<------------------------<>------------------------>\n');

fprintf(fid_W,'''VTIG: Mikrost - skupina 4''\n');

%fprintf(fid_W,'%4.2f 0.00 %4.2f 0.00\n',2^0.5 * sig_fi_3,2^0.5 * sig_fi_3); %smerodatn odchylka: rozdlu hlu [cc] , rozdlu dlek [mm] , jednotkov , souradnicov [mm]
fprintf(fid_W,'3.6 0.8 3.6 %.2f 0.00\n',m0); 


[n,pom] = size(body);

for i=1:n
    
    if(body(i,1) == 1)
        kod = 7;
    elseif(body(i,1) == 2)
        kod = 2;
    else
        kod = 0;
    end
    
    fprintf(fid_W,' %i %i %.1f %.1f %.1f\n',body(i,1),kod,1000*body(i,3),1000*body(i,2),1000*body(i,4));%bod , kod , X [mm], Y [mm] (kod:)
end

fprintf(fid_W,'-1\n');%nasleduji vodorovne mery

[n,pom] = size(data);

for i=1:n
    fprintf(fid_W,' %i %i %.1f %.2f\n',data(i,1:2),10000*data(i,3) , m0^2 / X_s_fi_I(data(i,1))^2   );%stanovisko , cl , smer [cc], vha
end

fprintf(fid_W,'-1\n');%naleduji zenitky

zenitky = zenit(mereni,10,X_s_z);

[n,pom] = size(zenitky);

for i=1:n
    fprintf(fid_W,' %i %i %.1f %.2f\n',zenitky(i,1:2),10000*zenitky(i,3),  m0^2 / zenitky(i,4)^2 );%stanovisko , cl , zenitka [cc], vha
end


fprintf(fid_W,'-1\n');%nasleduji sikme delky

[n,pom] = size(delky);

for i=1:n
    %fprintf(fid_W,' %i %i %.1f %.4f\n',delky(i,1:2),1000*delky(i,5), m0^2 / X_s_d(1,1)^2 );%stanovisko , cl , zenitka [cc], vha
    fprintf(fid_W,' %i %i %.1f 10\n',delky(i,1:2),1000*delky(i,3) );%stanovisko , cl , zenitka [cc], vha
end


fprintf(fid_W,'-1\n');

%fprintf(fid,'<------------------------<>------------------------>\n');
















fprintf(fid_R,'<?xml version="1.0" ?>\n');
fprintf(fid_R,'<!DOCTYPE gama-xml SYSTEM "gama-xml.dtd">\n');
fprintf(fid_R,'\n');
fprintf(fid_R,'<!-- vytvoril rsc pro Rocinante 1.0.0 -->\n');
fprintf(fid_R,'\n');
fprintf(fid_R,'<gama-xml version="2.0">\n');
fprintf(fid_R,'<network axes-xy = "sw"  angles="right-handed">\n');
fprintf(fid_R,'\n');
fprintf(fid_R,'<description>\n');
fprintf(fid_R,'\n');
fprintf(fid_R,'\n');
fprintf(fid_R,'</description>\n');
fprintf(fid_R,'\n');
fprintf(fid_R,'\n');
fprintf(fid_R,'<parameters\n');
fprintf(fid_R,'    sigma-apr = "3.6"\n');
fprintf(fid_R,'    conf-pr   = "0.950"\n');
fprintf(fid_R,'    tol-abs   = "1000.000"\n');
fprintf(fid_R,'    sigma-act = "apriori"\n');
fprintf(fid_R,'/>\n');
fprintf(fid_R,'\n');
fprintf(fid_R,'<points-observations direction-stdev="3.6" distance-stdev="%.2f 0.00 0.00" angle-stdev="5.1">\n',mer*0.06);
fprintf(fid_R,'\n');



[n,pom] = size(body);

for i=1:n
    
    if(body(i,1) == 1)
        %kod = 'fix="xyz"';
        fprintf(fid_R,'<point id=" 1" x="%7.4f" y="%7.4f" z="%7.4f" fix="xyz" />\n',100*mer,500*mer,10*mer);
    elseif(body(i,1) == 2)
        %kod = 2;
        fprintf(fid_R,'<point id=" 2" x="%.4f" y="%7.4f" adj="XYZ" />\n',mer*100+mer*mereni(1,5),500*mer);
    else
        %kod = 'adj="xyz"';
        fprintf(fid_R,'<point id="%2.i" adj="xyz" />\n',body(i,1));
    end
    
    
end




fprintf(fid_R,'  \n');

fprintf(fid_R,'<obs from="%2.i">\n',data(1,1));

[n,pom] = size(data);

ww = 1;

for i=1:n
    
   
    
    
    if((ww == 1) )
        ww = 0;
        
        qq = data(i,2);
        
    end
    
    %fprintf(fid_R,' <direction to="%2.i" val="%8.4f" stdev="%4.2f" />\n',data(i,2:3) ,  X_s_fi_I(data(i,1))   );%stanovisko , cl , smer [cc], vha
    
    
    if(data(i,2) ~= qq)
         fprintf(fid_R,' <angle to="%2.i" rs="%2.i" val="%8.4f" stdev="%4.2f" />\n',qq , data(i,2:3) ,  X_s_fi_I(data(i,1))   );%stanovisko , cl , smer [cc], vha
     end
    
    if(  (i < n) & (data(i+1,1) ~= data(i,1))    )
        fprintf(fid_R,'</obs>\n<obs from="%2.i">\n',data(i+1,1));
        
        ww = 1;
        
    end
    
end

fprintf(fid_R,'  \n');

zenitky = zenit(mereni,10,X_s_z);

[n,pom] = size(zenitky);


fprintf(fid_R,'</obs>\n\n<obs from="%2.i">\n',zenitky(1,1));

for i=1:n
    fprintf(fid_R,' <z-angle to="%2.i" val="%8.4f" stdev="%4.2f" />\n',zenitky(i,2),zenitky(i,3),  zenitky(i,4) );%stanovisko , cl , zenitka [cc], vha
    
    
        if(  (i < n) & (zenitky(i+1,1) ~= zenitky(i,1))    )
        fprintf(fid_R,'</obs>\n<obs from="%2.i">\n',zenitky(i+1,1));
    end
    
end

%fprintf(fid_R,'</obs>\n\n<obs from="%2.i">\n',zenitky(1,1));


fprintf(fid_R,'  \n');

fprintf(fid_R,'</obs>\n\n <obs from="%2.i">\n',delky(1,1));

delky = delka(mereni,10,X_s_d);

[n,pom] = size(delky);

for i=1:n
    fprintf(fid_R,'  <distance to="%2.i" val="%6.4f" stdev="%.2f" />\n',delky(i,2),mer*delky(i,3) ,mer*0.08);%stanovisko , cl , zenitka [cc], vha
    
    
    if(  (i < n) & (delky(i+1,1) ~= delky(i,1))    )
        fprintf(fid_R,'</obs>\n<obs from="%2.i">\n',delky(i+1,1));
    end
    
end


fprintf(fid_R,'</obs>\n');




fprintf(fid_R,'  \n');


fprintf(fid_R,'\n');
fprintf(fid_R,'\n');
fprintf(fid_R,'</points-observations>\n');
fprintf(fid_R,'\n');
fprintf(fid_R,'</network>\n');
fprintf(fid_R,'</gama-xml>\n');





 fclose(fid_W);

fclose(fid_R);

















% fclose(fid);
%fprintf('\n\nCseln vsledky jsou ulozeny v souboru "vtig_u04.txt" v pracovnm adresri\n\n');




